require 'spec_helper'


describe NlGasStations::GasStations do


  after :each do
    NlGasStations.reset
  end

  describe 'cache testing' do
    before {
      NlGasStations.configure do |config|
        config.cache = ActiveSupport::Cache::NullStore.new
      end
    }

    context 'check if cache exists' do
      subject(:cache) { NlGasStations.configuration.cache }

      it 'must not be nill' do
        expect(cache).to be_a ActiveSupport::Cache::Store
        expect(cache).to_not be nil
      end
    end

    context 'check funtionality with cache' do
      subject(:stations) { described_class.find_stations('9983', :euro_95, 10) }

      it 'should find data' do
        station_2 = stations[1]
        puts stations
        expect(station_2[:gas_station][:city]).to eq 'EEMSHAVEN'
      end
    end

  end


  describe 'find gas stations' do

    context 'search by short distance' do
      subject(:stations) { described_class.find_stations('9983', :lpg, 5) }

      it 'should return no results' do
        expect(stations).to eq []
      end
    end

    context 'search by a valid postal code and distance' do
      subject(:stations) { described_class.find_stations('9983', :diesel, 10) }

      it 'should find data' do
        puts stations
        station_1 = stations[0]
        expect(station_1[:gas_station][:name]).to eq 'Texaco Eemshaven'
        expect(station_1[:gas_station][:street_address]).to eq 'Schildweg 4a'
        expect(station_1[:gas_station][:postal_code]).to eq '9979XR'
        expect(station_1[:gas_station][:city]).to eq 'EEMSHAVEN'
        expect(station_1[:fuel_type]).to eq :diesel
        expect(station_1[:price]).to eq 1.239
        expect(station_1[:date]).to eq Date.new(2015, 2, 11)
      end
    end

  end


end
